/*
    WebCPULoad 0.2, un CGI para ver la carga de la CPU.
    Copyright (C) 2000 Paco Brufal <pbrufal@mutoid.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
 How to install WebCPULoad
 - You need libgd development packages
 - compile with 'gcc webcpuload.c -o webcpuload -Wall -O2 -lgd -lm'
 - copy the executable to cgi-bin directory
 - to use webcpuload put '<img src="/cgi-bin/webcpuload?bar">' or
 '<img src="/cgi-bin/webcpuload?pie">' in your web page.
 - Please, send me an e-mail if you put webcpuload in your web ;)

 Como usarlo:
 - Se necesita los paquetes de desarrollo de libgd
 - compilar con 'gcc webcpuload.c -o webcpuload -Wall -O2 -lgd -lm'
 - copiar al directorio de cgi's
 - en la pagina web poner '<img src="/cgi-bin/webcpuload?bar">' o
 '<img src="/cgi-bin/webcpuload?pie">'
 - Por favor, si lo pones en tu web, mandame un mail diciendomelo ;)
*/

/* Changelog:
- 8 August 2000,        0.1,    Initial Release
- 15 August 2000,       0.2,    Added a pie graph
*/

#include <gd.h>
#include <gdfonts.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

int main(int argc, char *argv[]) {
        gdImagePtr im;
        int black, white, red, a, b=15, c, green;
        int arco;
        long int *idle=0;
        long int *prog=0;
        long int *prev_idle;
        long int *prev_prog;
        int *idletime;
        int *progtime;
        int result;
        char cad[4];

        FILE    *cpu;

        char *s[10]={"100%","90%","80%","70%","60%","50%","40%","30%","20%","10%"};

        char temp[128];
        char usage[4];
        char *tokens = " \t\n";
        char *p;
        int i, graph=0;

        if(!strcmp("bar",argv[1])) {
                graph=1;
                im = gdImageCreate(92, 127);
        } else {
                graph=0;
                im = gdImageCreate(100, 120);
        }
        cpu = fopen ("/proc/stat", "r");
        for(c=0;c<2;c++) {
                prev_idle = idle;
                prev_prog = prog;

                prog = 0;
                idle = 0;

                fseek(cpu, 0, SEEK_SET);

                while(fgets(temp, 128, cpu)) {
                        if (strstr(temp, "cpu")) {
                                p = strtok(temp, tokens);
                                for (i=0 ; i<3 ; i++) {
                                        p = strtok (NULL, tokens);
                                        prog += (long) atol(p);
                                }
                                p = strtok(NULL, temp);
                                idle += atol(p);
                        }
                }
                sleep(1);
        }
        idletime = (int *)(idle - prev_idle);
        progtime = (int *)(prog - prev_prog);

        result = (int)progtime * 100 / ((int)idletime + (int)progtime);

        white = gdImageColorAllocate(im, 255, 255, 255);
        black = gdImageColorAllocate(im, 0, 0, 0);
        red = gdImageColorAllocate(im, 255, 0, 0);
        green = gdImageColorAllocate(im,0,255,0);

   if(graph==1) {
        gdImageFilledRectangle(im, 0, 0, 91, 126, black);
        gdImageFilledRectangle(im, 1, 1, 90, 125, white);
        gdImageFilledRectangle(im, 20, 117-result, 50, 117, red);
        gdImageString(im,gdFontSmall,20,0,"CPU LOAD",red);
        for(a=0;a<10;a++) {
                gdImageString(im, gdFontSmall,60 ,b, s[a], black);
                gdImageLine(im, 20, b+3, 50, b+3, black);
                b+=10;
        }
        sprintf(cad,"%d%%",result);
        if(result<100 && result>0) gdImageString(im,gdFontSmall,3,110-result,cad,black);
   } else {
        for(a=0;a<91;a++) gdImageArc(im, 50, 50, a, a, 0, 360, green);
        arco=((result*270)/75);
        for(a=0;a<91;a++) gdImageArc(im, 50, 50, a, a, 0, arco, red);
        sprintf(usage,"%d%%",result);
        gdImageString(im,gdFontSmall,50-(strlen(usage)/2),105,usage,black);
   }
        printf("Content-type: image/png\n\n");
        gdImagePng(im, stdout);
        gdImageDestroy(im);
        fclose(cpu);
        return 0;
}
